package com.StudentServices.MarksService.controller;

import com.StudentServices.MarksService.exception.ResourceNotFoundException;
import com.StudentServices.MarksService.model.StudentMarks;
import com.StudentServices.MarksService.service.StudentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@CrossOrigin(origins = "*")
@RestController
@RequestMapping("/api/")

public class StudentMarksController {

    @Autowired StudentService studentService;

    // (GET) findall studentmarks
    @GetMapping("/studentMarks")
    ResponseEntity<List<StudentMarks>> findAllStudentMarks(){
        return ResponseEntity.ok(studentService.findAllStudents());
    }
    // (POST) create studentmark
    @PostMapping("/studentMarks")
    public ResponseEntity<StudentMarks> createMarks(@RequestBody StudentMarks studentMarks) {
        return ResponseEntity.ok(studentService.addStudent(studentMarks));
    }

    // (GET) find studentmark by id
    @GetMapping("/studentMarks/{id}")
    ResponseEntity<StudentMarks> findStudentMarksById(@PathVariable String id) throws ResourceNotFoundException {

        StudentMarks sm = studentService.getStudentById(id).
                orElseThrow( () -> new ResourceNotFoundException("Student was not found: " + id));
        return ResponseEntity.ok(sm);
    }


    // (PUT) update studentmark by id

    // (DELETE) delete studentmark by id
    @DeleteMapping("remove/{id}")
    ResponseEntity<String> deleteStudentMarkById(@PathVariable String id) throws ResourceNotFoundException{
        StudentMarks sm = studentService.getStudentById(id).
                orElseThrow( () -> new ResourceNotFoundException("Student was not found: " + id));

        studentService.deleteStudent(sm);

        return ResponseEntity.ok("Successfully deleted student: " + sm.getEmailAddress());
    }

}
